package com.flyfish.framework.r2dbc.metadata.reference;

import com.flyfish.framework.annotations.Property;
import lombok.AllArgsConstructor;
import lombok.Data;
import org.springframework.data.mapping.PersistentEntity;
import org.springframework.data.mapping.PersistentProperty;

@Data
@Property("一对一关联查询")
@AllArgsConstructor
public class R2dbcAssociation {

    @Property("关联实体类")
    private PersistentEntity<?, ?> entity;

    @Property("关联字段")
    private PersistentProperty<?> field;

    @Property("目标字段")
    private FieldSetter setter;

    @Property("字段是否在当前实体内部")
    boolean inner;

    public static R2dbcAssociation of(PersistentEntity<?, ?> entity, PersistentProperty<?> field, FieldSetter setter, boolean inner) {
        return new R2dbcAssociation(entity, field, setter, inner);
    }
}
